import { IDanmaMessage, Point, Rect } from '../interface/IDanmaMessage';
import { IDanmaTrackInfo } from '../interface/IDanmaTrack';
export declare abstract class BaseMessage implements IDanmaMessage {
    created: boolean;
    distoryed: boolean;
    isLayout: boolean;
    position: Point;
    size: Rect;
    onBaseCreate(): void;
    onBaseDestroyed(): void;
    onBaseMeasure(ctx: CanvasRenderingContext2D, trackInfo: IDanmaTrackInfo): void;
    onBaseLayout(ctx: CanvasRenderingContext2D, trackInfo: IDanmaTrackInfo): void;
    onBaseDraw(ctx: CanvasRenderingContext2D, trackInfo: IDanmaTrackInfo): void;
    abstract onCreate(callback: Function): void;
    abstract onMeasure(ctx: CanvasRenderingContext2D, trackInfo: IDanmaTrackInfo): Rect;
    abstract onLayout(ctx: CanvasRenderingContext2D, trackInfo: IDanmaTrackInfo): Point;
    abstract onDraw(ctx: CanvasRenderingContext2D, trackInfo: IDanmaTrackInfo): void;
    abstract onDestroyed(): boolean;
}
